import java.util.ArrayList;

class Node {
	// label of this node : id of the attribute
	protected int attributeId ;
	
	// label of the node
	protected String label ;
	
	// sub-trees
	protected ArrayList<Node> subtrees;
	
	// labels of the edges : values of the attributes
	protected ArrayList<String> edgeLabels;
	
	/**
	 * Constructor 
	 *   internal node
	 */
    public Node(int id, String name, boolean leaf) {
	if (leaf) {
	    // the node is leaf
	    attributeId = id;  // id the value
	    label = name;      // name of the value
	    subtrees = null;
	    edgeLabels = null;
	} else {
	    // the node is not leaf
	    attributeId = id; // colomn of the attribute
	    label  = name;    // name of the attribute
	    subtrees = new ArrayList<Node>();
	    edgeLabels = new ArrayList<String>();
	}
    }
	
	/**
	 * Add a new subtree
	 *    with the corresponding label
	 */
	public void add(String l, Node subtree) {
		subtrees.add(subtree);
		edgeLabels.add(l);
	}
	
	/**
	*
	*/
	public ArrayList<Node> getSubtrees() {
		return subtrees;
	}
	
	/**
	*
	*/
	public ArrayList<String> getEdgeLabels() {
		return edgeLabels;
	}

	/**
	*
	*/
	public int getAttributeId() {
		return attributeId;
	}
		
	/**
	*
	*/
	public String getLabel() {
		return label;
	}
		
	/**
	 * Test if the node is a leaf
	 */
	public boolean leaf() {
		return subtrees == null;
	}
	
	public String toString() {
		String res = "";
		
		if (leaf()) {
	    res = "(" + label + ")";
		} else {
	    res = "([" + label + "]";
			
	    for(int i = 0; i < subtrees.size(); i++) {
				res += ", " + edgeLabels.get(i) + " " + subtrees.get(i).toString();
	    }
			
	    res += ")";
		}
		
		return res;
	}
	
}
